
// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2022 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

/************************************************************************
 *     DATE:        07/01/2003                                          *
 *                                                                $     *
 *     AUTEUR:      G RIO   (mailto:gerardrio56@free.fr)                *
 *                                                                $     *
 *     PROJET:      Herezh++                                            *
 *                                                                $     *
 ************************************************************************
 *     BUT:  Bannière du programme                                      *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *                                                                      *
 *     VERIFICATION:                                                    *
 *                                                                      *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *     !        !            !                                    !     *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *
 *     MODIFICATIONS:                                                   *
 *     !  date  !   auteur   !       but                          !     *
 *     ------------------------------------------------------------     *
 *                                                                $     *
 ************************************************************************/
#ifndef BANNIERE_H
#define BANNIERE_H

#include "ParaGlob.h"
#include "Tableau_T.h"

/// @addtogroup Les_parametres_generaux
///  @{
///


class Banniere
{
  public :
    // CONSTRUCTEURS :
    // création de la banniére
    Banniere() {};    
    // DESTRUCTEUR :
    ~Banniere();
    // METHODES PUBLIQUES :
    
    // affichage de la banniere sur la sortie passée en argument
    static void Sortie_banniere(ostream & sort);
    // affichage de la banniere sur cout
    static void Sortie_banniere();
    // passage en lecture de la banniere
    static void Passage_lecture_banniere(istream& entr);
    // retour du copie pirate
    static string CopiPirate(){return copipirate;};
    
  private :  
    // VARIABLES PROTEGEES :
    class Construc_banniere 
      { public: Construc_banniere(); };
    friend class Construc_banniere;  
    static Tableau <string> la_banniere;
    static string copipirate;
    static Construc_banniere construc_ban;  
    
     
 };
 /// @}  // end of group

#endif  
